; PID control for two wheel robot on SX (Ubicom) microcontroller.
; Copyright (C) 1999-2001 Blaise Gassend <blaise at gassend dot com>
; 
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

incdecb	macro	var,cond	; increment # 1 if # 2 else decrement
	local   a1, a2
	jnb	cond,a1
	inc	var
	snz	
	inc	var+1
	jmp	a2
a1
	test	var
	snz
	dec	var+1
	dec	var
a2
	endm

decincb	macro	var,cond	; decrement # 1 if # 2 else increment
	local   a1, a2
	jb	cond,a1
	inc	var
	snz	
	inc	var+1
	jmp	a2
a1
	test	var
	snz
	dec	var+1
	dec	var
a2
	sb	cond
	inc	var
	snb	cond
	dec	var
	endm

add816 	macro  	dest,src
	clc
	add	dest,src
	snc
	inc	dest+1
	endm

addnc	macro	dest,src
	clc
	add	dest,src
	endm

addc	macro	dest,src
	add	dest,src
	endm

addwc	macro	dest
	add	dest,W
	endm

;sextow 	macro src ; Extends the sign of src to W
;	mov	W,<<src
;	clr	W
;	snc
;	xor	W,#0FFh
;	endm

;jabove	macro	dest ; Jump above (not signed)
;	mov	W,#5
;	and	W,STATUS
;	xor	W,#1
;	jz	dest
;	endm

;jbelow	macro	dest ; Jump below (not signed)
;	jnc	dest
;	endm

cmp	macro	src,val
	mov	W,#val
	stc
	mov	W,src-W
	endm
