; PID control for two wheel robot on SX (Ubicom) microcontroller.
; Copyright (C) 1999-2001 Blaise Gassend <blaise at gassend dot com>
; 
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

        device  sx18ac, pages4, banks8, ircdiv1
        device  turbo, optionx, carryx

	reset init	

; Fuse  : 00B
; FuseX : B3F

; Modes

;CMP     equ     08h
WKPND   equ     09h
WKED    equ     0Ah
WKEN    equ     0Bh
ST      equ     0Ch
LVL     equ     0Dh
PLP     equ     0Eh
DIR     equ     0Fh


; ra bits

PWMOUT	equ	ra.0

	org 08h
pwmlen	ds 3
load	ds 1
curfrac ds 1
loadfrac ds 1

; ******************************

pwmmove	macro	speed,time ; time in .1s, max is approx 100 s
	mov	load,#speed
	mov	pwmlen,#0
	mov	pwmlen+1,#((time*56)*255)
	mov	pwmlen+2,#(((time*56)>>8)&255)
	call 	pwm
endm

	org 0h
init
	bank #0
	page #0

	clr	ra		; Prepare port a for output
        mov     W,#DIR
        mov     M,W
        mov     !ra,#1000b

	sb	rb.4
	jmp	done
waitforstart
	movb	ra.1,pwmlen+1.6
	clr	w
	stc
	add	pwmlen,w
	add	pwmlen+1,w
	add	pwmlen+2,w
	snb	rb.4
	jmp	waitforstart
	clrb	ra.1

; ******************************
	
	pwmmove	8,15
	pwmmove	16,15
	pwmmove	12,20

done
	mov	ra,#4
	jmp	done	

; *******************************

pwm
	mov	loadfrac,load
	mov	curfrac,#16
pwmloop ; takes 6.5 microseconds
	mov	W,#2 ; set output	 	; 1
	sb	loadfrac.7 		 	; 2
	mov	w,#3 				; 3
	mov	ra,W 				; 4

	mov	w,#16 ; handle pwm 		; 5
	dec	loadfrac 			; 6
	dec	curfrac 			; 7
	clc					; 8
	snz 					; 9
	add	loadfrac,w 			; 10
	test	curfrac				; 11
	clc					; 12
	snz					; 13
	add	curfrac,w			; 14

	clr	w ; when to stop		; 15
	clc					; 16
	sub	pwmlen,w			; 17
	sub	pwmlen+1,w			; 18
	sub	pwmlen+2,w			; 19
	test	pwmlen				; 20
	snz					; 21
	test	pwmlen+1			; 22
	snz					; 23
	test	pwmlen+2			; 24
	sz					; 25
	jmp	pwmloop				; 26 27 28
	
	clrb	PWMOUT				
	ret

end

	
