; PID control for two wheel robot on SX (Ubicom) microcontroller.
; Copyright (C) 1999-2001 Blaise Gassend <blaise at gassend dot com>
; 
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

; Counts to SPI.

	device  sx18ac, pages4, banks8, oschs
	device  turbo, optionx, carryx

	reset   init

; Port B bits

CK      equ     4
RX      equ     5
TX      equ     6
NSS	equ	7
MCK     equ     16
MRX     equ     32
MTX     equ     64
MNSS	equ	128

; Modes

;CMP     equ     08h
WKPND   equ     09h
WKED    equ     0Ah
WKEN    equ     0Bh
ST      equ     0Ch
LVL     equ     0Dh
PLP     equ     0Eh
DIR     equ     0Fh

; Ram

	org     8h
togo	ds	1
wait	ds	1
dist	ds	2
iodata	ds	1
inbuff	ds	3
bits	ds	1
spitogo ds	1
oldrb	ds	1
quadrant ds	1

	org     0
interrupt
	reti

init
        bank    #0
	mov	FSR,#08h  ;Clear memory
memclr  clr	INDF
	inc	FSR
	mov	W,#20h
	xor	W,FSR
	jnz	memclr

        mov     W,#11011000b ; Activate RTCC interrupt
        mov     !option,W

; Prepare PWM
	bank	#0
        mov     W,#DIR
        mov     M,W
        mov     !ra,#00000000b
	
	mov	FSR,#0
spiloop
	mov	oldrb,rb
waitss  mov	W,oldrb
	xor	W,rb ; wait for selection
	and	W,#MNSS
	jz	waitss

	mov	bits,#8
	
	clrb	rb.CK	
	mov	M,#DIR  ; Enable CK and TX
	mov	W,#10101111b
	mov	!rb,W

spisendloop
	call	spidelay

	clrb	rb.CK
	nop
	nop
	movb	rb.TX,iodata.7
	call	spidelay

	setb	rb.CK
	nop
	nop
	movb	C,rb.RX
	rl	iodata

	dec	bits
	jnz	spisendloop

	call	spidelay
	
	mov	M,#DIR ; TX and CK outputs again.
	mov	W,#11111111b
	mov	!rb,W

	jmp	spiloop

spidelay
	mov	spitogo,#0FFh
spidelayloop
	nop
	nop
	dec	spitogo
	jnz	spidelayloop
	ret

END
	

	


